package storage

import (
	"xbus.io/go-xbus/v3/api"
)

type Datatype string

func (d Datatype) String() string {
	return string(d)
}

const (
	DatatypeEnvelope Datatype = "envelope"
)

type NoSuchIDError struct {
	datatype Datatype
	id       api.UUID
}

func (err NoSuchIDError) Unwrap() error {
	return ErrNoSuchID
}

func (err NoSuchIDError) Error() string {
	return "No such " + err.datatype.String() + ": " + err.id.String()
}

func NewNoSuchIDError(datatype Datatype, id api.UUID) *NoSuchIDError {
	return &NoSuchIDError{
		datatype: datatype,
		id:       id,
	}
}
